//+------------------------------------------------------------------+
//|                                                     scalefix.mq4 |
//|                                @Copyright 2019 Lorentzos Roussos |
//|                              https://www.mql5.com/en/users/lorio |
//+------------------------------------------------------------------+
#property copyright "@Copyright 2019 Lorentzos Roussos"
#property link      "https://www.mql5.com/en/users/lorio"
#property version   "1.00"
#property strict
#property indicator_chart_window
bool scalefix=false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
  scalefix=false;
//--- indicator buffers mapping
  ObjectsDeleteAll(0,"SCALEFIX_");
  string objna="SCALEFIX_BTN";
  bool obji=ObjectCreate(0,objna,OBJ_BUTTON,0,0,0);
  ObjectSetInteger(0,objna,OBJPROP_XSIZE,100);
  ObjectSetInteger(0,objna,OBJPROP_YSIZE,16);
  ObjectSetInteger(0,objna,OBJPROP_XDISTANCE,5);
  ObjectSetInteger(0,objna,OBJPROP_YDISTANCE,52);
  scalefix=ChartGetInteger(0,CHART_SCALEFIX,0);
  if(scalefix==false) scalefix=ChartGetInteger(0,CHART_SCALEFIX_11,0);
  string text="Locked";
  if(scalefix==true) text="UnLocked";
  ObjectSetString(0,objna,OBJPROP_TEXT,text);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
    if(id==CHARTEVENT_OBJECT_CLICK&&sparam=="SCALEFIX_BTN")
    {
    bool check=scalefix;
    if(check==false)
      {
      ChartSetInteger(0,CHART_SCALEFIX,true);
      scalefix=true;
      ObjectSetString(0,sparam,OBJPROP_TEXT,"UnLocked");
      }
    if(check==true)
      {
      ChartSetInteger(0,CHART_SCALEFIX,false);
      scalefix=false;
      ObjectSetString(0,sparam,OBJPROP_TEXT,"Locked");      
      }
    ObjectSetInteger(0,sparam,OBJPROP_STATE,false);
    }
  }
//+------------------------------------------------------------------+
